/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.19.5
 *
 *     Copyright: (c) 2017 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_core.h"

        #include <wx/tooltip.h>

        #include <wx/window.h>
        #include <wx/object.h>
        #include <wx/object.h>
    void _wxToolTip_SetMaxWidth(int width)
    {
        #ifdef __WXMSW__
            wxToolTip::SetMaxWidth(width);
        #endif
    }


PyDoc_STRVAR(doc_wxToolTip_GetTip, "GetTip() -> String\n"
    "\n"
    "Get the tooltip text.");

extern "C" {static PyObject *meth_wxToolTip_GetTip(PyObject *, PyObject *);}
static PyObject *meth_wxToolTip_GetTip(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const  ::wxToolTip *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxToolTip, &sipCpp))
        {
             ::wxString*sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = new  ::wxString(sipCpp->GetTip());
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolTip, sipName_GetTip, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxToolTip_GetWindow, "GetWindow() -> Window\n"
    "\n"
    "Get the associated window.");

extern "C" {static PyObject *meth_wxToolTip_GetWindow(PyObject *, PyObject *);}
static PyObject *meth_wxToolTip_GetWindow(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const  ::wxToolTip *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxToolTip, &sipCpp))
        {
             ::wxWindow*sipRes;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipRes = sipCpp->GetWindow();
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromType(sipRes,sipType_wxWindow,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolTip, sipName_GetWindow, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxToolTip_SetTip, "SetTip(tip)\n"
    "\n"
    "Set the tooltip text.");

extern "C" {static PyObject *meth_wxToolTip_SetTip(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxToolTip_SetTip(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const  ::wxString* tip;
        int tipState = 0;
         ::wxToolTip *sipCpp;

        static const char *sipKwdList[] = {
            sipName_tip,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxToolTip, &sipCpp, sipType_wxString,&tip, &tipState))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp->SetTip(*tip);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast< ::wxString *>(tip),sipType_wxString,tipState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolTip, sipName_SetTip, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxToolTip_Enable, "Enable(flag)\n"
    "\n"
    "Enable or disable tooltips globally.");

extern "C" {static PyObject *meth_wxToolTip_Enable(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxToolTip_Enable(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        bool flag;

        static const char *sipKwdList[] = {
            sipName_flag,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "b", &flag))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
             ::wxToolTip::Enable(flag);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolTip, sipName_Enable, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxToolTip_SetAutoPop, "SetAutoPop(msecs)\n"
    "\n"
    "Set the delay after which the tooltip disappears or how long a tooltip\n"
    "remains visible.");

extern "C" {static PyObject *meth_wxToolTip_SetAutoPop(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxToolTip_SetAutoPop(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        long msecs;

        static const char *sipKwdList[] = {
            sipName_msecs,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "l", &msecs))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
             ::wxToolTip::SetAutoPop(msecs);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolTip, sipName_SetAutoPop, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxToolTip_SetDelay, "SetDelay(msecs)\n"
    "\n"
    "Set the delay after which the tooltip appears.");

extern "C" {static PyObject *meth_wxToolTip_SetDelay(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxToolTip_SetDelay(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        long msecs;

        static const char *sipKwdList[] = {
            sipName_msecs,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "l", &msecs))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
             ::wxToolTip::SetDelay(msecs);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolTip, sipName_SetDelay, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxToolTip_SetMaxWidth, "SetMaxWidth(width)\n"
    "\n"
    "Set tooltip maximal width in pixels.");

extern "C" {static PyObject *meth_wxToolTip_SetMaxWidth(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxToolTip_SetMaxWidth(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        int width;

        static const char *sipKwdList[] = {
            sipName_width,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "i", &width))
        {
            int sipIsErr = 0;

        PyErr_Clear();
        Py_BEGIN_ALLOW_THREADS
        _wxToolTip_SetMaxWidth(width);
        Py_END_ALLOW_THREADS
        if (PyErr_Occurred()) sipIsErr = 1;

            if (sipIsErr)
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolTip, sipName_SetMaxWidth, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxToolTip_SetReshow, "SetReshow(msecs)\n"
    "\n"
    "Set the delay between subsequent tooltips to appear.");

extern "C" {static PyObject *meth_wxToolTip_SetReshow(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxToolTip_SetReshow(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        long msecs;

        static const char *sipKwdList[] = {
            sipName_msecs,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "l", &msecs))
        {
            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
             ::wxToolTip::SetReshow(msecs);
            Py_END_ALLOW_THREADS

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ToolTip, sipName_SetReshow, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its inheritance hierarchy. */
extern "C" {static void *cast_wxToolTip(void *, const sipTypeDef *);}
static void *cast_wxToolTip(void *sipCppV, const sipTypeDef *targetType)
{
     ::wxToolTip *sipCpp = reinterpret_cast< ::wxToolTip *>(sipCppV);

    if (targetType == sipType_wxObject)
        return static_cast< ::wxObject *>(sipCpp);

    return sipCppV;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxToolTip(void *, int);}
static void release_wxToolTip(void *sipCppV, int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast< ::wxToolTip *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void dealloc_wxToolTip(sipSimpleWrapper *);}
static void dealloc_wxToolTip(sipSimpleWrapper *sipSelf)
{
    if (sipIsOwnedByPython(sipSelf))
    {
        release_wxToolTip(sipGetAddress(sipSelf), 0);
    }
}


extern "C" {static void *init_type_wxToolTip(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxToolTip(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
     ::wxToolTip *sipCpp = 0;

    {
        const  ::wxString* tip;
        int tipState = 0;

        static const char *sipKwdList[] = {
            sipName_tip,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J1", sipType_wxString,&tip, &tipState))
        {

        if (!wxPyCheckForApp()) return NULL;

            PyErr_Clear();

            Py_BEGIN_ALLOW_THREADS
            sipCpp = new  ::wxToolTip(*tip);
            Py_END_ALLOW_THREADS
            sipReleaseType(const_cast< ::wxString *>(tip),sipType_wxString,tipState);

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_wxToolTip[] = {{348, 255, 1}};


static PyMethodDef methods_wxToolTip[] = {
    {SIP_MLNAME_CAST(sipName_Enable), (PyCFunction)meth_wxToolTip_Enable, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxToolTip_Enable)},
    {SIP_MLNAME_CAST(sipName_GetTip), meth_wxToolTip_GetTip, METH_VARARGS, SIP_MLDOC_CAST(doc_wxToolTip_GetTip)},
    {SIP_MLNAME_CAST(sipName_GetWindow), meth_wxToolTip_GetWindow, METH_VARARGS, SIP_MLDOC_CAST(doc_wxToolTip_GetWindow)},
    {SIP_MLNAME_CAST(sipName_SetAutoPop), (PyCFunction)meth_wxToolTip_SetAutoPop, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxToolTip_SetAutoPop)},
    {SIP_MLNAME_CAST(sipName_SetDelay), (PyCFunction)meth_wxToolTip_SetDelay, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxToolTip_SetDelay)},
    {SIP_MLNAME_CAST(sipName_SetMaxWidth), (PyCFunction)meth_wxToolTip_SetMaxWidth, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxToolTip_SetMaxWidth)},
    {SIP_MLNAME_CAST(sipName_SetReshow), (PyCFunction)meth_wxToolTip_SetReshow, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxToolTip_SetReshow)},
    {SIP_MLNAME_CAST(sipName_SetTip), (PyCFunction)meth_wxToolTip_SetTip, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxToolTip_SetTip)}
};

sipVariableDef variables_wxToolTip[] = {
    {PropertyVariable, sipName_Window, &methods_wxToolTip[2], NULL, NULL, NULL},
    {PropertyVariable, sipName_Tip, &methods_wxToolTip[1], &methods_wxToolTip[7], NULL, NULL},
};

PyDoc_STRVAR(doc_wxToolTip, "ToolTip(tip)\n"
    "\n"
    "This class holds information about a tooltip associated with a window\n"
    "(see wxWindow::SetToolTip()).");


sipClassTypeDef sipTypeDef__core_wxToolTip = {
    {
        -1,
        0,
        0,
        SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_wxToolTip,
        {0},
        0
    },
    {
        sipNameNr_ToolTip,
        {0, 0, 1},
        8, methods_wxToolTip,
        0, 0,
        2, variables_wxToolTip,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxToolTip,
    -1,
    -1,
    supers_wxToolTip,
    0,
    init_type_wxToolTip,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxToolTip,
    0,
    0,
    0,
    release_wxToolTip,
    cast_wxToolTip,
    0,
    0,
    0,
    0,
    0,
    0
};
